import{s as V,f as N,n as X,o as Z}from"../chunks/scheduler.37c15a92.js";import{S as ee,i as te,g as a,s as l,r as ne,A as ie,h as s,f as n,c as o,j as O,u as ae,x as c,k as w,y as le,a as i,v as se,d as oe,t as re,w as ue}from"../chunks/index.7cb9c9b8.js";import{H as ce}from"../chunks/Heading.d3928e2a.js";function me(R){let r,T,y,C,m,L,p,A,P,f,Q="In the last unit, we learned about Deep Q-Learning. In this value-based deep reinforcement learning algorithm, we <strong>used a deep neural network to approximate the different Q-values for each possible action at a state.</strong>",H,d,U="Since the beginning of the course, we have only studied value-based methods, <strong>where we estimate a value function as an intermediate step towards finding an optimal policy.</strong>",$,h,D,I,g,F="In value-based methods, the policy <strong>(π) only exists because of the action value estimates since the policy is just a function</strong> (for instance, greedy-policy) that will select the action with the highest value given a state.",k,v,W="With policy-based methods, we want to optimize the policy directly <strong>without having an intermediate step of learning a value function.</strong>",E,_,Y=`So today, <strong>we’ll learn about policy-based methods and study a subset of these methods called policy gradient</strong>. Then we’ll implement our first policy gradient algorithm called Monte Carlo <strong>Reinforce</strong> from scratch using PyTorch.
Then, we’ll test its robustness using the CartPole-v1 and PixelCopter environments.`,j,x,B="You’ll then be able to iterate and improve this implementation for more advanced environments.",S,u,J='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/envs.gif" alt="Environments"/>',q,b,K="Let’s get started!",z,M,G;return m=new ce({props:{title:"Introduction",local:"introduction",headingTag:"h1"}}),{c(){r=a("meta"),T=l(),y=a("p"),C=l(),ne(m.$$.fragment),L=l(),p=a("img"),P=l(),f=a("p"),f.innerHTML=Q,H=l(),d=a("p"),d.innerHTML=U,$=l(),h=a("img"),I=l(),g=a("p"),g.innerHTML=F,k=l(),v=a("p"),v.innerHTML=W,E=l(),_=a("p"),_.innerHTML=Y,j=l(),x=a("p"),x.textContent=B,S=l(),u=a("figure"),u.innerHTML=J,q=l(),b=a("p"),b.textContent=K,z=l(),M=a("p"),this.h()},l(e){const t=ie("svelte-u9bgzb",document.head);r=s(t,"META",{name:!0,content:!0}),t.forEach(n),T=o(e),y=s(e,"P",{}),O(y).forEach(n),C=o(e),ae(m.$$.fragment,e),L=o(e),p=s(e,"IMG",{src:!0,alt:!0}),P=o(e),f=s(e,"P",{"data-svelte-h":!0}),c(f)!=="svelte-j9zk2f"&&(f.innerHTML=Q),H=o(e),d=s(e,"P",{"data-svelte-h":!0}),c(d)!=="svelte-2xpx7a"&&(d.innerHTML=U),$=o(e),h=s(e,"IMG",{src:!0,alt:!0}),I=o(e),g=s(e,"P",{"data-svelte-h":!0}),c(g)!=="svelte-10c158u"&&(g.innerHTML=F),k=o(e),v=s(e,"P",{"data-svelte-h":!0}),c(v)!=="svelte-1btggbm"&&(v.innerHTML=W),E=o(e),_=s(e,"P",{"data-svelte-h":!0}),c(_)!=="svelte-4of5it"&&(_.innerHTML=Y),j=o(e),x=s(e,"P",{"data-svelte-h":!0}),c(x)!=="svelte-liqaak"&&(x.textContent=B),S=o(e),u=s(e,"FIGURE",{class:!0,"data-svelte-h":!0}),c(u)!=="svelte-1dadvfq"&&(u.innerHTML=J),q=o(e),b=s(e,"P",{"data-svelte-h":!0}),c(b)!=="svelte-4b3xjd"&&(b.textContent=K),z=o(e),M=s(e,"P",{}),O(M).forEach(n),this.h()},h(){w(r,"name","hf:doc:metadata"),w(r,"content",pe),N(p.src,A="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/thumbnail.png")||w(p,"src",A),w(p,"alt","thumbnail"),N(h.src,D="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/link-value-policy.jpg")||w(h,"src",D),w(h,"alt","Link value policy"),w(u,"class","image table text-center m-0 w-full")},m(e,t){le(document.head,r),i(e,T,t),i(e,y,t),i(e,C,t),se(m,e,t),i(e,L,t),i(e,p,t),i(e,P,t),i(e,f,t),i(e,H,t),i(e,d,t),i(e,$,t),i(e,h,t),i(e,I,t),i(e,g,t),i(e,k,t),i(e,v,t),i(e,E,t),i(e,_,t),i(e,j,t),i(e,x,t),i(e,S,t),i(e,u,t),i(e,q,t),i(e,b,t),i(e,z,t),i(e,M,t),G=!0},p:X,i(e){G||(oe(m.$$.fragment,e),G=!0)},o(e){re(m.$$.fragment,e),G=!1},d(e){e&&(n(T),n(y),n(C),n(L),n(p),n(P),n(f),n(H),n(d),n($),n(h),n(I),n(g),n(k),n(v),n(E),n(_),n(j),n(x),n(S),n(u),n(q),n(b),n(z),n(M)),n(r),ue(m,e)}}}const pe='{"title":"Introduction","local":"introduction","sections":[],"depth":1}';function fe(R){return Z(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ve extends ee{constructor(r){super(),te(this,r,fe,me,V,{})}}export{ve as component};
